import {fileOpen as $42h8L$fileOpen} from "browser-fs-access";
import $42h8L$turndown from "turndown";
import {strikethrough as $42h8L$strikethrough, tables as $42h8L$tables, taskListItems as $42h8L$taskListItems, gfm as $42h8L$gfm} from "turndown-plugin-gfm";
import {blobOf as $42h8L$blobOf, parseDOM as $42h8L$parseDOM, walkDOM as $42h8L$walkDOM, insertToCursor as $42h8L$insertToCursor} from "web-utility";
import {marked as $42h8L$marked} from "marked";


function $parcel$export(e, n, v, s) {
  Object.defineProperty(e, n, {get: v, set: s, enumerable: true, configurable: true});
}
var $57ba63c17513cbba$exports = {};

$parcel$export($57ba63c17513cbba$exports, "getAnchorElement", function () { return $57ba63c17513cbba$export$ac81f1ba58a5f363; });
$parcel$export($57ba63c17513cbba$exports, "Tool", function () { return $57ba63c17513cbba$export$724f6b867059ef5f; });
$parcel$export($57ba63c17513cbba$exports, "FileTool", function () { return $57ba63c17513cbba$export$de3122b2484864a7; });

function $57ba63c17513cbba$export$ac81f1ba58a5f363() {
    const { anchorNode: anchorNode } = self.getSelection() || {};
    if (anchorNode) return anchorNode.parentElement;
}
class $57ba63c17513cbba$export$724f6b867059ef5f {
    get usable() {
        const { command: command } = this;
        return !command || document.queryCommandSupported(command) || document.queryCommandEnabled(command);
    }
    getActive() {
        const { command: command, tags: tags } = this;
        if (tags) {
            const box = $57ba63c17513cbba$export$ac81f1ba58a5f363();
            return !!box && box.matches(tags.map((tag)=>`${tag}, ${tag} *`).join(", "));
        }
        if (command) return document.queryCommandState(command);
        return false;
    }
    get active() {
        return this.getActive();
    }
    get title() {
        const { name: name, keys: keys, usable: usable } = this;
        return `${name}${usable ? keys ? `\n(${keys.join(" + ")})` : "" : "\n(not supported)"}`;
    }
    edit(editor, ...data) {
        editor.focus();
        document.execCommand(this.command, null, ...data);
    }
    execute(editor, ...data) {
        var { inputs: inputs } = this, values = [];
        if (inputs) {
            const data = inputs.map((input)=>self.prompt(input));
            if (!data.filter(Boolean)[0]) return;
            values = data;
        }
        this.edit(editor, ...values);
    }
}
class $57ba63c17513cbba$export$de3122b2484864a7 extends $57ba63c17513cbba$export$724f6b867059ef5f {
    async save(data) {
        return URL.createObjectURL(data);
    }
    codeOf(path) {
        return path;
    }
    async execute(editor) {
        try {
            var path = await this.save(await (0, $42h8L$fileOpen)());
        } catch  {
            var path = self.prompt("No file uploaded, please input an URL");
        }
        if (path) this.edit(editor, this.codeOf(path));
    }
}


var $761e5fca3dae08eb$exports = {};

$parcel$export($761e5fca3dae08eb$exports, "BoldTool", function () { return $761e5fca3dae08eb$export$10056a49e3b218eb; });
$parcel$export($761e5fca3dae08eb$exports, "ItalicTool", function () { return $761e5fca3dae08eb$export$edf99d0f51bacb1e; });
$parcel$export($761e5fca3dae08eb$exports, "UnderlineTool", function () { return $761e5fca3dae08eb$export$4b6d9c17188960d2; });
$parcel$export($761e5fca3dae08eb$exports, "StrikeThroughTool", function () { return $761e5fca3dae08eb$export$a35bffaeae8fdda0; });
$parcel$export($761e5fca3dae08eb$exports, "H1Tool", function () { return $761e5fca3dae08eb$export$30e8c6b428f8749f; });
$parcel$export($761e5fca3dae08eb$exports, "H2Tool", function () { return $761e5fca3dae08eb$export$58443375efa91029; });
$parcel$export($761e5fca3dae08eb$exports, "H3Tool", function () { return $761e5fca3dae08eb$export$75d24d6b8b747307; });
$parcel$export($761e5fca3dae08eb$exports, "FontSizeDownTool", function () { return $761e5fca3dae08eb$export$a20806c6ef6938f8; });
$parcel$export($761e5fca3dae08eb$exports, "FontSizeUpTool", function () { return $761e5fca3dae08eb$export$744da7e24e4a7382; });
$parcel$export($761e5fca3dae08eb$exports, "SubscriptTool", function () { return $761e5fca3dae08eb$export$6137518b4e998008; });
$parcel$export($761e5fca3dae08eb$exports, "SuperscriptTool", function () { return $761e5fca3dae08eb$export$7217f06c61ebd4fc; });
$parcel$export($761e5fca3dae08eb$exports, "LinkTool", function () { return $761e5fca3dae08eb$export$f6c54364b5332e66; });

class $761e5fca3dae08eb$export$10056a49e3b218eb extends (0, $57ba63c17513cbba$export$724f6b867059ef5f) {
    constructor(...args){
        super(...args);
        this.name = "Bold";
        this.tags = [
            "b",
            "strong"
        ];
        this.keys = [
            "Ctrl",
            "B"
        ];
        this.command = "bold";
    }
}
class $761e5fca3dae08eb$export$edf99d0f51bacb1e extends (0, $57ba63c17513cbba$export$724f6b867059ef5f) {
    constructor(...args){
        super(...args);
        this.name = "Italic";
        this.tags = [
            "i",
            "em"
        ];
        this.keys = [
            "Ctrl",
            "I"
        ];
        this.command = "italic";
    }
}
class $761e5fca3dae08eb$export$4b6d9c17188960d2 extends (0, $57ba63c17513cbba$export$724f6b867059ef5f) {
    constructor(...args){
        super(...args);
        this.name = "Underline";
        this.tags = [
            "u"
        ];
        this.keys = [
            "Ctrl",
            "U"
        ];
        this.command = "underline";
    }
}
class $761e5fca3dae08eb$export$a35bffaeae8fdda0 extends (0, $57ba63c17513cbba$export$724f6b867059ef5f) {
    constructor(...args){
        super(...args);
        this.name = "Strike through";
        this.tags = [
            "s",
            "del",
            "strike"
        ];
        this.command = "strikeThrough";
    }
}
const $761e5fca3dae08eb$var$HeadingCommand = document.queryCommandSupported("heading") ? "heading" : "formatBlock";
class $761e5fca3dae08eb$export$30e8c6b428f8749f extends (0, $57ba63c17513cbba$export$724f6b867059ef5f) {
    execute(editor) {
        this.edit(editor, "H1");
    }
    constructor(...args){
        super(...args);
        this.name = "H1";
        this.tags = [
            "h1"
        ];
        this.command = $761e5fca3dae08eb$var$HeadingCommand;
    }
}
class $761e5fca3dae08eb$export$58443375efa91029 extends (0, $57ba63c17513cbba$export$724f6b867059ef5f) {
    execute(editor) {
        this.edit(editor, "H2");
    }
    constructor(...args){
        super(...args);
        this.name = "H2";
        this.tags = [
            "h2"
        ];
        this.command = $761e5fca3dae08eb$var$HeadingCommand;
    }
}
class $761e5fca3dae08eb$export$75d24d6b8b747307 extends (0, $57ba63c17513cbba$export$724f6b867059ef5f) {
    execute(editor) {
        this.edit(editor, "H3");
    }
    constructor(...args){
        super(...args);
        this.name = "H3";
        this.tags = [
            "h3"
        ];
        this.command = $761e5fca3dae08eb$var$HeadingCommand;
    }
}
class $761e5fca3dae08eb$export$a20806c6ef6938f8 extends (0, $57ba63c17513cbba$export$724f6b867059ef5f) {
    constructor(...args){
        super(...args);
        this.name = "Font Size down";
        this.tags = [
            "small"
        ];
        this.command = "decreaseFontSize";
    }
}
class $761e5fca3dae08eb$export$744da7e24e4a7382 extends (0, $57ba63c17513cbba$export$724f6b867059ef5f) {
    constructor(...args){
        super(...args);
        this.name = "Font Size up";
        this.tags = [
            "big"
        ];
        this.command = "increaseFontSize";
    }
}
class $761e5fca3dae08eb$export$6137518b4e998008 extends (0, $57ba63c17513cbba$export$724f6b867059ef5f) {
    constructor(...args){
        super(...args);
        this.name = "Subscript";
        this.tags = [
            "sub"
        ];
        this.command = "subscript";
    }
}
class $761e5fca3dae08eb$export$7217f06c61ebd4fc extends (0, $57ba63c17513cbba$export$724f6b867059ef5f) {
    constructor(...args){
        super(...args);
        this.name = "Superscript";
        this.tags = [
            "sup"
        ];
        this.command = "superscript";
    }
}
class $761e5fca3dae08eb$export$f6c54364b5332e66 extends (0, $57ba63c17513cbba$export$724f6b867059ef5f) {
    constructor(...args){
        super(...args);
        this.name = "Link";
        this.tags = [
            "a"
        ];
        this.inputs = [
            "Path"
        ];
        this.command = "createLink";
    }
}


var $e999eec76d3b8abe$exports = {};

$parcel$export($e999eec76d3b8abe$exports, "ColorTool", function () { return $e999eec76d3b8abe$export$ba9bbe5370f1bf2f; });
$parcel$export($e999eec76d3b8abe$exports, "ForeColorTool", function () { return $e999eec76d3b8abe$export$cab0e15cfb8489d7; });
$parcel$export($e999eec76d3b8abe$exports, "BackColorTool", function () { return $e999eec76d3b8abe$export$92bb6183e7459be2; });

class $e999eec76d3b8abe$export$ba9bbe5370f1bf2f extends (0, $57ba63c17513cbba$export$724f6b867059ef5f) {
    getColor() {
        const box = (0, $57ba63c17513cbba$export$ac81f1ba58a5f363)(), { colorName: colorName } = this;
        if (!box) return colorName === "color" ? "#000000" : "#ffffff";
        const { [colorName]: color } = getComputedStyle(box);
        const [red, green, blue] = color.match(/\d+/g);
        return "#" + (+red).toString(16).padStart(2, "0") + (+green).toString(16).padStart(2, "0") + (+blue).toString(16).padStart(2, "0");
    }
    get active() {
        return !!this.getColor();
    }
    execute(editor, color) {
        this.edit(editor, color);
    }
}
class $e999eec76d3b8abe$export$cab0e15cfb8489d7 extends $e999eec76d3b8abe$export$ba9bbe5370f1bf2f {
    constructor(...args){
        super(...args);
        this.name = "Fore Color";
        this.command = "foreColor";
        this.colorName = "color";
    }
}
class $e999eec76d3b8abe$export$92bb6183e7459be2 extends $e999eec76d3b8abe$export$ba9bbe5370f1bf2f {
    constructor(...args){
        super(...args);
        this.name = "Back Color";
        this.command = "backColor";
        this.colorName = "backgroundColor";
    }
}


var $258f24df7a3cbf67$exports = {};

$parcel$export($258f24df7a3cbf67$exports, "AlignTool", function () { return $258f24df7a3cbf67$export$6c1211091eb3b68f; });
$parcel$export($258f24df7a3cbf67$exports, "AlignLeftTool", function () { return $258f24df7a3cbf67$export$42a444ebfdcfe7b9; });
$parcel$export($258f24df7a3cbf67$exports, "AlignCenterTool", function () { return $258f24df7a3cbf67$export$9a2e6e0294a984eb; });
$parcel$export($258f24df7a3cbf67$exports, "AlignRightTool", function () { return $258f24df7a3cbf67$export$22363f91860fc258; });
$parcel$export($258f24df7a3cbf67$exports, "AlignFullTool", function () { return $258f24df7a3cbf67$export$42827b1362fed748; });
$parcel$export($258f24df7a3cbf67$exports, "OrderedListTool", function () { return $258f24df7a3cbf67$export$faf4e70f09f43a15; });
$parcel$export($258f24df7a3cbf67$exports, "UnorderedListTool", function () { return $258f24df7a3cbf67$export$cf4030b57a3fbe37; });
$parcel$export($258f24df7a3cbf67$exports, "HorizontalRuleTool", function () { return $258f24df7a3cbf67$export$dce8a7d6279fc201; });

class $258f24df7a3cbf67$export$6c1211091eb3b68f extends (0, $57ba63c17513cbba$export$724f6b867059ef5f) {
    get active() {
        if (super.getActive()) return true;
        const box = (0, $57ba63c17513cbba$export$ac81f1ba58a5f363)();
        return !!box && getComputedStyle(box).textAlign === this.align;
    }
}
class $258f24df7a3cbf67$export$42a444ebfdcfe7b9 extends $258f24df7a3cbf67$export$6c1211091eb3b68f {
    constructor(...args){
        super(...args);
        this.name = "Align Left";
        this.command = "justifyLeft";
        this.align = "left";
    }
}
class $258f24df7a3cbf67$export$9a2e6e0294a984eb extends $258f24df7a3cbf67$export$6c1211091eb3b68f {
    constructor(...args){
        super(...args);
        this.name = "Align Center";
        this.command = "justifyCenter";
        this.align = "center";
    }
}
class $258f24df7a3cbf67$export$22363f91860fc258 extends $258f24df7a3cbf67$export$6c1211091eb3b68f {
    constructor(...args){
        super(...args);
        this.name = "Align Right";
        this.command = "justifyRight";
        this.align = "right";
    }
}
class $258f24df7a3cbf67$export$42827b1362fed748 extends $258f24df7a3cbf67$export$6c1211091eb3b68f {
    constructor(...args){
        super(...args);
        this.name = "Align Full";
        this.command = "justifyFull";
        this.align = "justify";
    }
}
class $258f24df7a3cbf67$export$faf4e70f09f43a15 extends (0, $57ba63c17513cbba$export$724f6b867059ef5f) {
    constructor(...args){
        super(...args);
        this.name = "Ordered list";
        this.tags = [
            "ol"
        ];
        this.command = "insertOrderedList";
    }
}
class $258f24df7a3cbf67$export$cf4030b57a3fbe37 extends (0, $57ba63c17513cbba$export$724f6b867059ef5f) {
    constructor(...args){
        super(...args);
        this.name = "Unordered list";
        this.tags = [
            "ul"
        ];
        this.command = "insertUnorderedList";
    }
}
class $258f24df7a3cbf67$export$dce8a7d6279fc201 extends (0, $57ba63c17513cbba$export$724f6b867059ef5f) {
    constructor(...args){
        super(...args);
        this.name = "Horizontal rule";
        this.tags = [
            "hr"
        ];
        this.command = "insertHorizontalRule";
    }
}


var $0769f8c709024b7a$exports = {};

$parcel$export($0769f8c709024b7a$exports, "IFrameTool", function () { return $0769f8c709024b7a$export$3e557574863db086; });
$parcel$export($0769f8c709024b7a$exports, "ImageTool", function () { return $0769f8c709024b7a$export$982f47444a2f88da; });
$parcel$export($0769f8c709024b7a$exports, "AudioTool", function () { return $0769f8c709024b7a$export$6024938f37e646f8; });
$parcel$export($0769f8c709024b7a$exports, "VideoTool", function () { return $0769f8c709024b7a$export$932111b8028f79ed; });

class $0769f8c709024b7a$export$3e557574863db086 extends (0, $57ba63c17513cbba$export$724f6b867059ef5f) {
    execute(editor) {
        const path = self.prompt("Path");
        if (path) this.edit(editor, `<iframe style="width: 100%; height: 50vh; border: none" src="${path}"></iframe>`);
    }
    constructor(...args){
        super(...args);
        this.name = "Embed Web page";
        this.tags = [
            "iframe"
        ];
        this.command = "insertHTML";
    }
}
class $0769f8c709024b7a$export$982f47444a2f88da extends (0, $57ba63c17513cbba$export$de3122b2484864a7) {
    codeOf(path) {
        return `<img style="max-width: 100%; height: auto" src="${path}"/>`;
    }
    constructor(...args){
        super(...args);
        this.name = "Image";
        this.tags = [
            "img"
        ];
        this.command = "insertHTML";
    }
}
class $0769f8c709024b7a$export$6024938f37e646f8 extends (0, $57ba63c17513cbba$export$de3122b2484864a7) {
    codeOf(path) {
        return `<audio controls src="${path}"></audio>`;
    }
    constructor(...args){
        super(...args);
        this.name = "Audio";
        this.tags = [
            "audio"
        ];
        this.command = "insertHTML";
    }
}
class $0769f8c709024b7a$export$932111b8028f79ed extends (0, $57ba63c17513cbba$export$de3122b2484864a7) {
    codeOf(path) {
        return `<video controls src="${path}"></video>`;
    }
    constructor(...args){
        super(...args);
        this.name = "Video";
        this.tags = [
            "video"
        ];
        this.command = "insertHTML";
    }
}


var $2c12cf671c105d76$exports = {};

$parcel$export($2c12cf671c105d76$exports, "UndoTool", function () { return $2c12cf671c105d76$export$65235875731ff287; });
$parcel$export($2c12cf671c105d76$exports, "RedoTool", function () { return $2c12cf671c105d76$export$b60f30d254d1e1a6; });
$parcel$export($2c12cf671c105d76$exports, "ResetTool", function () { return $2c12cf671c105d76$export$6f46dc3d81fbb4bd; });
$parcel$export($2c12cf671c105d76$exports, "ClearTool", function () { return $2c12cf671c105d76$export$25eb377ce1feaada; });

class $2c12cf671c105d76$export$65235875731ff287 extends (0, $57ba63c17513cbba$export$724f6b867059ef5f) {
    constructor(...args){
        super(...args);
        this.name = "Undo";
        this.command = "undo";
    }
}
class $2c12cf671c105d76$export$b60f30d254d1e1a6 extends (0, $57ba63c17513cbba$export$724f6b867059ef5f) {
    constructor(...args){
        super(...args);
        this.name = "Redo";
        this.command = "redo";
    }
}
class $2c12cf671c105d76$export$6f46dc3d81fbb4bd extends (0, $57ba63c17513cbba$export$724f6b867059ef5f) {
    constructor(...args){
        super(...args);
        this.name = "Reset";
        this.command = "removeFormat";
    }
}
class $2c12cf671c105d76$export$25eb377ce1feaada extends (0, $57ba63c17513cbba$export$724f6b867059ef5f) {
    execute(editor) {
        editor.focus();
        document.execCommand("selectAll");
        document.execCommand("delete");
    }
    constructor(...args){
        super(...args);
        this.name = "Clear";
    }
}


var $6e883fb0ea04260a$exports = {};

$parcel$export($6e883fb0ea04260a$exports, "turndown", function () { return $6e883fb0ea04260a$export$48d4d6bf65314082; });
$parcel$export($6e883fb0ea04260a$exports, "CopyMarkdownTool", function () { return $6e883fb0ea04260a$export$4b13df0a6effdd72; });



const $6e883fb0ea04260a$var$Empty_HREF = /^(#|javascript:\s*void\(0\);?\s*)$/;
const $6e883fb0ea04260a$export$48d4d6bf65314082 = new (0, $42h8L$turndown)({
    hr: "---",
    linkStyle: "referenced",
    headingStyle: "atx",
    bulletListMarker: "-",
    codeBlockStyle: "fenced"
}).use((0, $42h8L$strikethrough)).use((0, $42h8L$tables)).use((0, $42h8L$taskListItems)).use((0, $42h8L$gfm)).addRule("non_url", {
    filter: (node)=>[
            "a",
            "area"
        ].includes(node.nodeName.toLowerCase()) && $6e883fb0ea04260a$var$Empty_HREF.test(node.getAttribute("href") || ""),
    replacement: ()=>""
}).addRule("img-srcset", {
    filter: [
        "img"
    ],
    replacement (_, { alt: alt, title: title, src: src, srcset: srcset }) {
        const [firstSet] = srcset.split(",")[0]?.split(/\s+/) || [];
        const content = [
            src || firstSet,
            title && JSON.stringify(title)
        ].filter(Boolean);
        return `![${alt}](${content.join(" ")})`;
    }
}).addRule("source-srcset", {
    filter: [
        "picture"
    ],
    replacement (_, node) {
        const { src: src, alt: alt, title: title } = node.querySelector("img") || {};
        const sourceList = Array.from(node.querySelectorAll("source"), ({ sizes: sizes, srcset: srcset })=>{
            const size = Math.max(...sizes.split(/,|\)/).map((pixel)=>parseFloat(pixel.trim())).filter(Boolean));
            const [src] = srcset.split(",")[0]?.split(/\s+/) || [];
            return {
                size: size,
                src: src
            };
        });
        const sources = sourceList.sort(({ size: a }, { size: b })=>b - a);
        const content = [
            src || sources[0]?.src,
            title && JSON.stringify(title)
        ].filter(Boolean);
        return `![${alt}](${content.join(" ")})`;
    }
}).remove((node)=>node.matches('style, script, aside, form, [class*="ads" i]')).keep((node)=>node.matches("kbd, iframe"));
class $6e883fb0ea04260a$export$4b13df0a6effdd72 extends (0, $57ba63c17513cbba$export$724f6b867059ef5f) {
    async execute({ innerHTML: innerHTML }, ...data) {
        const markdown = $6e883fb0ea04260a$export$48d4d6bf65314082.turndown(innerHTML);
        await navigator.clipboard.writeText(markdown);
        alert("Markdown copied to clipboard");
    }
    constructor(...args){
        super(...args);
        this.name = "Copy Markdown";
        this.icon = "markdown";
    }
}


var $b738b8c7b1139833$exports = {};

$parcel$export($b738b8c7b1139833$exports, "editor", function () { return $b738b8c7b1139833$export$b5d042d2b680aed6; });


const $b738b8c7b1139833$export$b5d042d2b680aed6 = (Class, {})=>class EditorTrait extends Class {
        async uploadFile(tool, data) {
            if (typeof data === "string" && !/^(data|blob):/.test(data)) return data;
            try {
                return await tool.save(typeof data === "string" ? await (0, $42h8L$blobOf)(data) : data);
            } catch (error) {
                console.error(error);
                if (typeof data === "string") return data;
            }
        }
        async clearHTML(markup) {
            const { imageTool: imageTool, audioTool: audioTool, videoTool: videoTool } = this, fragment = document.createDocumentFragment();
            fragment.append(...(0, $42h8L$parseDOM)(markup));
            for (const element of (0, $42h8L$walkDOM)(fragment, Node.ELEMENT_NODE)){
                const { style: style, dataset: dataset } = element;
                if ([
                    "nowrap",
                    "pre"
                ].includes(style.whiteSpace)) style.whiteSpace = "normal";
                for(const key in dataset)delete dataset[key];
                if (element instanceof HTMLImageElement && imageTool) element.src = await this.uploadFile(imageTool, element.src);
                else if (element instanceof HTMLAudioElement && audioTool) element.src = await this.uploadFile(audioTool, element.src);
                else if (element instanceof HTMLVideoElement && videoTool) element.src = await this.uploadFile(videoTool, element.src);
            }
            return fragment;
        }
        constructor(...args){
            super(...args);
            this.handlePasteDrop = async (event)=>{
                event.preventDefault();
                const root = event.currentTarget;
                const list = event.type === "paste" ? [
                    ...event.clipboardData.items
                ] : [
                    ...event.dataTransfer.items
                ];
                const { imageTool: imageTool, audioTool: audioTool, videoTool: videoTool } = this;
                root.focus();
                const [plainText, htmlText] = list.filter(({ type: type })=>type.startsWith("text/"));
                if (!htmlText && plainText.type === "text/plain") {
                    const raw = await new Promise((resolve)=>plainText.getAsString(resolve));
                    (0, $42h8L$insertToCursor)(await this.clearHTML((0, $42h8L$marked)(raw)));
                } else for (const item of list)if (item.type === "text/html") {
                    const raw = await new Promise((resolve)=>item.getAsString(resolve));
                    (0, $42h8L$insertToCursor)(await this.clearHTML(raw));
                } else if (item.type.startsWith("image/") && imageTool) {
                    const URI = await this.uploadFile(imageTool, item.getAsFile());
                    if (URI) (0, $42h8L$insertToCursor)((0, $42h8L$parseDOM)(`<img src="${URI}" />`)[0]);
                } else if (item.type.startsWith("audio/") && audioTool) {
                    const URI = await this.uploadFile(audioTool, item.getAsFile());
                    if (URI) (0, $42h8L$insertToCursor)((0, $42h8L$parseDOM)(`<audio src="${URI}" />`)[0]);
                } else if (item.type.startsWith("video/") && videoTool) {
                    const URI = await this.uploadFile(videoTool, item.getAsFile());
                    if (URI) (0, $42h8L$insertToCursor)((0, $42h8L$parseDOM)(`<video src="${URI}" />`)[0]);
                }
                this.updateValue(root.innerHTML);
            };
        }
    };




export {$57ba63c17513cbba$export$ac81f1ba58a5f363 as getAnchorElement, $57ba63c17513cbba$export$724f6b867059ef5f as Tool, $57ba63c17513cbba$export$de3122b2484864a7 as FileTool, $761e5fca3dae08eb$export$10056a49e3b218eb as BoldTool, $761e5fca3dae08eb$export$edf99d0f51bacb1e as ItalicTool, $761e5fca3dae08eb$export$4b6d9c17188960d2 as UnderlineTool, $761e5fca3dae08eb$export$a35bffaeae8fdda0 as StrikeThroughTool, $761e5fca3dae08eb$export$30e8c6b428f8749f as H1Tool, $761e5fca3dae08eb$export$58443375efa91029 as H2Tool, $761e5fca3dae08eb$export$75d24d6b8b747307 as H3Tool, $761e5fca3dae08eb$export$a20806c6ef6938f8 as FontSizeDownTool, $761e5fca3dae08eb$export$744da7e24e4a7382 as FontSizeUpTool, $761e5fca3dae08eb$export$6137518b4e998008 as SubscriptTool, $761e5fca3dae08eb$export$7217f06c61ebd4fc as SuperscriptTool, $761e5fca3dae08eb$export$f6c54364b5332e66 as LinkTool, $e999eec76d3b8abe$export$ba9bbe5370f1bf2f as ColorTool, $e999eec76d3b8abe$export$cab0e15cfb8489d7 as ForeColorTool, $e999eec76d3b8abe$export$92bb6183e7459be2 as BackColorTool, $258f24df7a3cbf67$export$6c1211091eb3b68f as AlignTool, $258f24df7a3cbf67$export$42a444ebfdcfe7b9 as AlignLeftTool, $258f24df7a3cbf67$export$9a2e6e0294a984eb as AlignCenterTool, $258f24df7a3cbf67$export$22363f91860fc258 as AlignRightTool, $258f24df7a3cbf67$export$42827b1362fed748 as AlignFullTool, $258f24df7a3cbf67$export$faf4e70f09f43a15 as OrderedListTool, $258f24df7a3cbf67$export$cf4030b57a3fbe37 as UnorderedListTool, $258f24df7a3cbf67$export$dce8a7d6279fc201 as HorizontalRuleTool, $0769f8c709024b7a$export$3e557574863db086 as IFrameTool, $0769f8c709024b7a$export$982f47444a2f88da as ImageTool, $0769f8c709024b7a$export$6024938f37e646f8 as AudioTool, $0769f8c709024b7a$export$932111b8028f79ed as VideoTool, $2c12cf671c105d76$export$65235875731ff287 as UndoTool, $2c12cf671c105d76$export$b60f30d254d1e1a6 as RedoTool, $2c12cf671c105d76$export$6f46dc3d81fbb4bd as ResetTool, $2c12cf671c105d76$export$25eb377ce1feaada as ClearTool, $6e883fb0ea04260a$export$48d4d6bf65314082 as turndown, $6e883fb0ea04260a$export$4b13df0a6effdd72 as CopyMarkdownTool, $b738b8c7b1139833$export$b5d042d2b680aed6 as editor};
//# sourceMappingURL=index.esm.js.map
